<?php
/* =====================================================================
 * Dieses Skript ist Teil von "Wetter-Analyse in Dekaden (WADE)"
 * Von "Trixi aus Witten/NRW" - http://taw-wade.kilu.de/
 *                 Version 13.04.01 - Build 03.04.2013
 * Lizenziert unter "Namensnennung-Weitergabe unter gleichen Bedingungen
 * 3.0 Deutschland (CC BY-SA 3.0)"
 *                 ==> http://creativecommons.org/licenses/by-sa/3.0/de/
 *
 * Diese Software ist FREIE SOFTWARE und wird mit der Hoffnung, daß sie
 * nützlich sein könnte, zur Verfügung gestellt, jedoch OHNE JEDE
 * GEWÄHRLEISTUNG. Auch nicht für eine ALLGEMEINE GEBRAUCHSTAUGLICHKEIT
 * oder Stabilität für die NUTZUNG ZU EINEM BESTIMMTEN ZWECK. Die freie
 * Software, von der hier die Rede sein soll, ist kein "Freibier",
 * sondern sie gibt dir die Freiheiten
 *
 *   o  die Software für einen beliebigen Zweck auszuführen
 *   o  die Funktionsweise der Software zu studieren und sie an deine
 *      eigenen Bedürfnisse anzupassen
 *   o  Kopien der Software weiterzugeben
 *   o  sowie die Software zu verbessern und diese Verbesserungen zu
 *      veröffentlichen.
*/
// @module grafik "\t\tZeichnet die Vektorgrafik einer Station\n"
$DA->KonsolenAusgabe('Beginne mit der Ausführung von '.basename(__FILE__),1);
	if ( !is_dir($einstellungen['zwischenspeicher']['speicher_pfad']) )
	$DA->KonsolenAusgabe('Das Verzeichnis für den Zwischenspeicher existiert nicht',-1);
	if ( strlen($DA->cli_parameter['station']) < 4 )
	$DA->KonsolenAusgabe('Es wurde keine Station mit "--station=[name]" angegeben',-1);
	if ( !isset($einstellungen['daten'][$DA->cli_parameter['station']]) )
	$DA->KonsolenAusgabe('Diese Station befindet sich nicht in der Konfiguration',-1);
	if ( $DA->cli_parameter['vergleich'] === '' )
	$DA->KonsolenAusgabe('Es wurde kein Vergleichszeitraum mit "--vergleich=[jahre]" angegeben',-1);
	if ( $DA->cli_parameter['jahr'] === 0 )
	$DA->KonsolenAusgabe('Es wurde kein Jahr mit "--jahr=[jahr]" angegeben',-1);
	if ( !in_array($DA->cli_parameter['typ'],array('abweichung','mittel','absolut'),true) )
	$DA->cli_parameter['typ'] = 'abweichung';

		if ( $DA->cli_parameter['typ'] !== 'absolut' )
		$klima = $DA->HoleVergleichsMittelDerJahre($DA->cli_parameter['station'],$DA->cli_parameter['vergleich']);
		else
		$klima = array();
		if ( $DA->cli_parameter['typ'] !== 'mittel' )
		$daten = $DA->HoleStationsDatenDesJahres($DA->cli_parameter['station'],$DA->cli_parameter['jahr']);
		else
		$daten = array();


$daten_name = ( $DA->cli_parameter['typ'] === 'mittel' ) ? 'klima' : 'daten';
$werte_zeigen_mapping = array();
$jahres_abweichung = array();
$jahres_werte = array();
$platz_belegt = array();
$spalte = 0;

$DA->KonsolenAusgabe(print_r($klima,true),4);
$DA->KonsolenAusgabe(print_r($daten,true),4);
$DA->KonsolenAusgabe('Datenbearbeitung beendet',1);

$DA->KonsolenAusgabe('Erstellen der Vektorgrafik',1);
$DA->VektorGrafikPuffer('leinwand','rect','x=0,y=0,width=%w,height=%h,fill=url(#bg-gradient),stroke=black,stroke-width=3px');
$DA->VektorGrafikPuffer('leinwand','rect','x=!,y=!,width=%w-!!,height=%h-!!,fill=white,stroke=black,stroke-width=1px');

$DA->KonsolenAusgabe('Bearbeite Y-Achse des Diagramms',2);

	switch ( $DA->cli_parameter['typ'] ){
	case 'abweichung':
	$schritte = $einstellungen['grafik']['diagramm_y_achse_maximum']*2;
	$y_achse_alle_x_schritte = floor($schritte/($einstellungen['grafik']['hoehe']/25))+1;
/*		if ( $schritte > 30 )
		$y_achse_alle_x_schritte = 2;
		else
		$y_achse_alle_x_schritte = 1;*/
		for ( $wert = (0-$einstellungen['grafik']['diagramm_y_achse_maximum']) ; $wert <= $einstellungen['grafik']['diagramm_y_achse_maximum'] ; $wert++ ){
		$basis_y = $DA->BerechneYAchse_Abweichung($wert);
		$DA->VektorGrafikPuffer('y-achse-innen','line','x1=!,y1='.$basis_y[0].',x2=%w-!,y2='.$basis_y[0]);
		$DA->VektorGrafikPuffer('y-achse-aussen','line','x1=!-5,y1='.$basis_y[0].',x2=!,y2='.$basis_y[0]);
			if ( $wert > 0 )
			$wert_str = '+'.$wert;
			else
			$wert_str = $wert;
			if ( $wert !== 0 && $wert%$y_achse_alle_x_schritte === 0 )
			$DA->VektorGrafikPuffer('y-achse-aussen','text','x=8,y='.intval($basis_y[0]+5),$wert_str);
		}
	break;
	case 'mittel': case 'absolut':
	$begrenzung = array('min'=>0,'max'=>0);
		foreach ( $einstellungen['grafik']['diagramm_balken_daten'] as $balken_schluessel=>$balken_name ){
		$balken_name = explode(',',$balken_name);
			foreach ( $DA->grundgeruest_dekaden as $dekade=>$null ){
				if ( !isset(${$daten_name}[$dekade][$balken_name[0]]) )
				continue;
			$wert_aktuell = ${$daten_name}[$dekade][$balken_name[0]];
				if ( $wert_aktuell > $begrenzung['max'] )
				$begrenzung['max'] = $wert_aktuell;
				if ( $wert_aktuell < $begrenzung['min'] )
				$begrenzung['min'] = $wert_aktuell;
			}
		}
	$begrenzung['max'] = ceil(1.1*$begrenzung['max']);
		if ( $einstellungen['grafik']['diagramm_y_achse_maximum'] !== -1 && $einstellungen['grafik']['diagramm_y_achse_maximum'] > $begrenzung['max'] )
		$begrenzung['max'] = $einstellungen['grafik']['diagramm_y_achse_maximum'];
		if ( $begrenzung['min'] < 0 )
		$begrenzung['min'] = floor(1.2*$begrenzung['min']);
	$schritte = $begrenzung['max']-$begrenzung['min'];
	$y_achse_alle_x_schritte = floor($schritte/($einstellungen['grafik']['hoehe']/25))+1;
		for ( $wert = $begrenzung['min'] ; $wert <= $begrenzung['max'] ; $wert++ ){
		$basis_y = $DA->BerechneYAchse_Absolut($wert,$begrenzung);
		$DA->VektorGrafikPuffer('y-achse-innen','line','x1=!,y1='.$basis_y[0].',x2=%w-!,y2='.$basis_y[0]);
		$DA->VektorGrafikPuffer('y-achse-aussen','line','x1=!-5,y1='.$basis_y[0].',x2=!,y2='.$basis_y[0]);
			if ( $wert%$y_achse_alle_x_schritte === 0 )
			$DA->VektorGrafikPuffer('y-achse-aussen','text','x=8,y='.intval($basis_y[0]+5),$wert);
		}
	break;
	}

$DA->KonsolenAusgabe('Bearbeite X-Achse des Diagramms',2);
$zellenbreite = round( ($einstellungen['grafik']['breite']-(2*$einstellungen['grafik']['diagramm_abstand']))/36, 2);
$zellenabstand = intval($einstellungen['grafik']['diagramm_balken_abstand']);
$balkenbreite = -1;
	if ( $einstellungen['grafik']['diagramm_balken_breite'] <= 0 )
	$einstellungen['grafik']['diagramm_balken_breite'] = ($zellenbreite-(2*$zellenabstand))/sizeof($einstellungen['grafik']['diagramm_balken_daten']);
	else{
	$balkenbreite = $einstellungen['grafik']['diagramm_balken_breite']*sizeof($einstellungen['grafik']['diagramm_balken_daten']);
	$zellenabstand = ($zellenbreite-$balkenbreite)/2;
	}
//print_r("gesamt-breite:$zellenbreite seiten-abstand:$zellenabstand alle-balken:$balkenbreite 1-balken:".$einstellungen['grafik']['diagramm_balken_breite']."\r\n");

	foreach ( $DA->grundgeruest_dekaden as $dekade=>$null ){
		if ( !isset($klima) || !isset($daten) )
		break;
	$basis_x = $spalte*$zellenbreite+$einstellungen['grafik']['diagramm_abstand'];
		if ( $basis_x+$zellenbreite > $einstellungen['grafik']['breite'] )
		break;

		if ( $spalte === 0 ){
			foreach ( $einstellungen['grafik']['diagramm_balken_daten'] as $balken_schluessel=>$balken_name ){
			$balken_name = explode(',',$balken_name);
				if ( in_array('werte_zeigen',$balken_name,true) ){
				$werte_zeigen_mapping[$balken_schluessel] = sizeof($werte_zeigen_mapping);
				$basis_y = ($werte_zeigen_mapping[$balken_schluessel]*$einstellungen['grafik']['diagramm_werte_zeigen_hoehe'])+$einstellungen['grafik']['diagramm_abstand'];
				$DA->VektorGrafikPuffer('diagramm-werte-zeigen','rect','x=!,y='.$basis_y.',width=%w-!!,height='.intval($einstellungen['grafik']['diagramm_werte_zeigen_hoehe']).',class=cfill'.$balken_schluessel);
				}
			}
		}

		foreach ( $einstellungen['grafik']['diagramm_balken_daten'] as $balken_schluessel=>$balken_name ){
		$balken_name = explode(',',$balken_name);

			switch ( $DA->cli_parameter['typ'] ){
			case 'abweichung':
				if ( !isset($daten[$dekade][$balken_name[0]]) )
				continue;
				if ( !isset($jahres_abweichung[$balken_name[0]]) )
				$jahres_abweichung[$balken_name[0]] = array();
			$wert_klima = $klima[$dekade][$balken_name[0]];
			$wert_aktuell = $daten[$dekade][$balken_name[0]];
			$abweichung = round($wert_aktuell-$wert_klima,1);
			$jahres_abweichung[$balken_name[0]][] = $abweichung;
			$jahres_werte[$balken_name[0]][] = $wert_aktuell;
			$basis_y = $DA->BerechneYAchse_Abweichung($abweichung);
				//if ( abs($abweichung) > abs($einstellungen['grafik']['diagramm_y_achse_maximum']) ) print_r($basis_y);
			$DA->VektorGrafikPuffer('diagramm-balken','rect',str_replace(array(chr(9),chr(10)),array('',' '),'x='.($basis_x+$zellenabstand+($balken_schluessel*$einstellungen['grafik']['diagramm_balken_breite'])).',
				y='.$basis_y[1].',rx=2,ry=2,width='.intval($einstellungen['grafik']['diagramm_balken_breite']).',height='.$basis_y[2].',class=cfill'.$balken_schluessel.',opacity='.doubleval($balken_name[3])));
				if ( in_array('werte_zeigen',$balken_name,true) ){
				$basis_y = ($werte_zeigen_mapping[$balken_schluessel]*$einstellungen['grafik']['diagramm_werte_zeigen_hoehe'])+$einstellungen['grafik']['diagramm_abstand'];
				$DA->VektorGrafikPuffer('diagramm-werte','text','x='.($basis_x+$zellenabstand).',y='.($basis_y+($einstellungen['grafik']['diagramm_werte_zeigen_hoehe']/1.5)),number_format($wert_aktuell,1));
				}
			break;
			case 'mittel': case 'absolut':
				if ( !isset(${$daten_name}[$dekade][$balken_name[0]]) )
				continue;
			$wert_aktuell = ${$daten_name}[$dekade][$balken_name[0]];
			$jahres_abweichung[$balken_name[0]][] = 0;
			$jahres_werte[$balken_name[0]][] = $wert_aktuell;
			$basis_y = $DA->BerechneYAchse_Absolut($wert_aktuell,$begrenzung);
				if ( $einstellungen['grafik']['nullen_entfernen'] && $wert_aktuell == 0 ){}
				else{
					if ( !isset($platz_belegt[$basis_x.'.'.$basis_y[0]]) )
					$platz_belegt[$basis_x.'.'.$basis_y[0]] = 0;
				$radius = $einstellungen['grafik']['diagramm_balken_breite']-$platz_belegt[$basis_x.'.'.$basis_y[0]];
				$DA->VektorGrafikPuffer('diagramm-balken','circle',str_replace(array(chr(9),chr(10)),array('',' '),'cx='.($basis_x+($zellenbreite/2)).',
					cy='.$basis_y[0].',r='.$radius.',class=cfill'.$balken_schluessel.',opacity='.doubleval($balken_name[3])));
				$platz_belegt[$basis_x.'.'.$basis_y[0]] += 2;
				}
				if ( in_array('werte_zeigen',$balken_name,true) ){
				$basis_y = ($werte_zeigen_mapping[$balken_schluessel]*$einstellungen['grafik']['diagramm_werte_zeigen_hoehe'])+$einstellungen['grafik']['diagramm_abstand'];
				$DA->VektorGrafikPuffer('diagramm-werte','text','x='.($basis_x+2).',y='.($basis_y+10),number_format($wert_aktuell,1));
				}
			break;
			}
		}

	$DA->VektorGrafikPuffer('x-achse-aussen','line','x1='.$basis_x.',y1=%h-!,x2='.$basis_x.',y2=%h-'.($einstellungen['grafik']['diagramm_abstand']-5));
	$monat = $DA->StrMonatNachZahl(substr($dekade,0,strpos($dekade,'/')));
	$dekade = explode(chr(10),$DA->DekadeNachLokalisiertesDatum($dekade));
	$DA->VektorGrafikPuffer('x-achse-aussen','text','x='.($basis_x+10).',y=%h-32,class=klein',$dekade[1]);
		if ( (int)$dekade[1] === 2 )
		$DA->VektorGrafikPuffer('x-achse-aussen','text','x='.$basis_x.',y=%h-18,class=gross,style=font-weight:bold',$dekade[0]);
		if ( $spalte%3 === 0 && $spalte !== 1 ){
		$DA->VektorGrafikPuffer('x-achse-innen','line','x1='.$basis_x.',y1=!,x2='.$basis_x.',y2=%h-!');
			if ( $DA->StrMonatNachZahl($monat)%2 === 0 )
			$DA->VektorGrafikPuffer('leinwand','rect','x='.($basis_x+1).',y=!+1,width='.($zellenbreite*3-2).',height='.($einstellungen['grafik']['hoehe']-(2*$einstellungen['grafik']['diagramm_abstand'])-2).',fill=#f4f4f4,stroke=none');
		}
	$spalte++;
	}

$DA->KonsolenAusgabe('Bearbeite Legende',2);

$DA->VektorGrafikPuffer('kopf-info','text','x=600,y=15','Name der Station: '.
	$einstellungen['daten'][$DA->cli_parameter['station']]['name'].
	' ('.$einstellungen['daten'][$DA->cli_parameter['station']]['code'].
	') - '.$einstellungen['daten'][$DA->cli_parameter['station']]['quelle']);
$DA->VektorGrafikPuffer('kopf-info','text','x=600,y=30','Mittel der Jahre zum Vergleich: '.$DA->cli_parameter['vergleich']);

	foreach ( $einstellungen['grafik']['diagramm_balken_daten'] as $balken_schluessel=>$balken_name ){
	$basis_x = ($balken_schluessel*$einstellungen['grafik']['diagramm_legende_abstand'])+$einstellungen['grafik']['diagramm_abstand'];
	$balken_name = explode(',',$balken_name);
		if ( !isset($jahres_abweichung[$balken_name[0]]) )
		continue;
		if ( in_array('legende_nur_name',$balken_name,true) )
		$absolut = '';
		elseif ( in_array('legende_mittel_zeigen',$balken_name,true) )
		$absolut = ' ['.round( array_sum($jahres_werte[$balken_name[0]]) / sizeof($jahres_werte[$balken_name[0]]), 1).']';
		elseif ( in_array('legende_summe_zeigen',$balken_name,true) )
		$absolut = ' ['.round( array_sum($jahres_werte[$balken_name[0]]), 1).']';
		else{
		$absolut = array_sum($jahres_abweichung[$balken_name[0]])/sizeof($jahres_abweichung[$balken_name[0]]);
			if ( $absolut > 0 )
			$absolut = ' [+'.round($absolut,1).']';
			else
			$absolut = ' ['.round($absolut,1).']';
		}
	$DA->VektorGrafikPuffer('legende','rect','x='.$basis_x.',y=!-12,width=8,height=8,class=cfill'.$balken_schluessel);
	$DA->VektorGrafikPuffer('legende','text','x='.($basis_x+12).',y=!-4',$balken_name[2].$absolut);
	}

	switch ( $DA->cli_parameter['typ'] ){
	case 'abweichung':
	$kommentar = 'Wetter-Rückblick des Jahres '.$DA->cli_parameter['jahr'];
	$DA->VektorGrafikPuffer('kopf-ueberschrift','text','x=!,y=30',$kommentar);
	$basis_y = $DA->BerechneYAchse_Abweichung(0);
	break;
	case 'mittel':
	$kommentar = 'Klima-Mittelwerte der Station';
	$DA->VektorGrafikPuffer('kopf-ueberschrift','text','x=!,y=30',$kommentar);
	$basis_y = $DA->BerechneYAchse_Absolut(0,$begrenzung);
	break;
	case 'absolut':
	$kommentar = 'Wetter-Rückblick des Jahres '.$DA->cli_parameter['jahr'];
	$DA->VektorGrafikPuffer('kopf-ueberschrift','text','x=!,y=30',$kommentar);
	$basis_y = $DA->BerechneYAchse_Absolut(0,$begrenzung);
	break;
	}

	if ( ( isset($begrenzung) && $begrenzung['min'] !== 0 ) || $DA->cli_parameter['typ'] === 'abweichung' )
	$DA->VektorGrafikPuffer('y-achse-innen','line','x1=!,y1='.$basis_y[0].',x2=%w-!,y2='.$basis_y[0].',class=nullinie');
$fuss = 'Erstellt mit "Wetter-Analyse in Dekaden/'.WADE_VERSION_STRING.'" am '.date('d/m/Y H:i:s T');
	if ( strlen($einstellungen['report']['lizenz_text']) > 20 ){
	$fuss .= ', lizenziert unter '.htmlspecialchars($einstellungen['report']['lizenz_text']);
		if ( strlen($einstellungen['report']['lizenz_uri']) > 8 )
		$fuss .= ' ('.$einstellungen['report']['lizenz_uri'].')';
	}
$DA->VektorGrafikPuffer('fuss','text','x=20,y=%h-4',$fuss);

$DA->VektorGrafikZeichnen($kommentar.' - '.$einstellungen['daten'][$DA->cli_parameter['station']]['name'].' (CLINO '.$DA->cli_parameter['vergleich'].')');
$DA->KonsolenAusgabe('Vektorgrafik gezeichet in "'.$einstellungen['grafik']['ausgabe_datei_maske'].'"',1);
$DA->KonsolenAusgabe('Aufgaben erledigt. Ciao!',0);
?>
