<?php
/* =====================================================================
 * Dieses Skript ist Teil von "Wetter-Analyse in Dekaden (WADE)"
 * Von "Trixi aus Witten/NRW" - http://taw-wade.kilu.de/
 *                 Version 13.04.01 - Build 03.04.2013
 * Lizenziert unter "Namensnennung-Weitergabe unter gleichen Bedingungen
 * 3.0 Deutschland (CC BY-SA 3.0)"
 *                 ==> http://creativecommons.org/licenses/by-sa/3.0/de/
 *
 * Diese Software ist FREIE SOFTWARE und wird mit der Hoffnung, daß sie
 * nützlich sein könnte, zur Verfügung gestellt, jedoch OHNE JEDE
 * GEWÄHRLEISTUNG. Auch nicht für eine ALLGEMEINE GEBRAUCHSTAUGLICHKEIT
 * oder Stabilität für die NUTZUNG ZU EINEM BESTIMMTEN ZWECK. Die freie
 * Software, von der hier die Rede sein soll, ist kein "Freibier",
 * sondern sie gibt dir die Freiheiten
 *
 *   o  die Software für einen beliebigen Zweck auszuführen
 *   o  die Funktionsweise der Software zu studieren und sie an deine
 *      eigenen Bedürfnisse anzupassen
 *   o  Kopien der Software weiterzugeben
 *   o  sowie die Software zu verbessern und diese Verbesserungen zu
 *      veröffentlichen.
*/
	function WADE_Nur_Verfuegbare_Module(&$verfuegbar,$moeglich){
	$moeglich = explode(',',$moeglich);
		foreach ( $moeglich as $schluessel=>$wert ){
			if ( !in_array($wert,$verfuegbar,true) )
			unset($moeglich[$schluessel]);
		}
		if ( sizeof($moeglich) > 0 )
		return '(nur '.implode(',',$moeglich).')';
		else
		return '';
	}

class Dekaden_Analyse {
protected $nutze_optimierungen = true;
protected $niederschlagsgrenze_fuer_regentag_in_mm = 0.1; // nach DWD-Definition
public $cli_parameter = array(
	'debug_ausgabe'=>0,
	'update_download'=>false,
	'update_install'=>false,
	'konfiguration'=>'~/benutzer_beispiel.ini',
	'aktion'=>'',
	'station'=>'',
	'vergleich'=>'',
	'jahr'=>0,
	'typ'=>'text',
	'bedingung'=>'',
	'benutzer1'=>'',
	'benutzer2'=>'',
	'benutzer3'=>'',
	'benutzer4'=>''
	);
public $datenreihen = array(
	'temperatur_max',
	'temperatur_mit',
	'temperatur_min',
	'luftdruck_mit',
	'feuchte_mit',
	'wind_mit',
	'sonne',
	'niederschlag',
	'schneehoehe',
/*	'wolken_6h',
	'wolken_12h',
	'wolken_18h',*/
	'wolken_mit',
	'%tropentag',
	'%sommertag',
	'%frosttag',
	'%eistag',
	'%tropennacht',
	'%regentag',
	'%schneetag',
	'%sonnenschein'
);
public $grundgeruest_werte = array();
public $grundgeruest_dekaden = array();
public $startzeit = 0;

	public function __construct(){
	global $einstellungen;
		foreach ( $this->datenreihen as $d )
		$this->grundgeruest_werte[$d] = 0;
		for ( $m = 1 ; $m <= 12 ; $m++ ){
			for ( $d = 1 ; $d <= 3 ; $d++ )
			$this->grundgeruest_dekaden[$m.'/'.$d] = $this->grundgeruest_werte;
		}
	$this->startzeit = microtime(true);
	$this->BearbeiteKommandozeilenParameter($GLOBALS['argv']);
	$makro = array('~/','%station%','%jahr%','%typ%','%aktion%','%benutzer1%','%benutzer2%','%benutzer3%','%benutzer4%','%paramhash%');
	$ersetzen = array(dirname(__FILE__).'/',$this->cli_parameter['station'],$this->cli_parameter['jahr'],
		$this->cli_parameter['typ'],$this->cli_parameter['aktion'],
		$this->cli_parameter['benutzer1'],$this->cli_parameter['benutzer2'],$this->cli_parameter['benutzer3'],$this->cli_parameter['benutzer4'],
		sprintf('%u',crc32(print_r($this->cli_parameter,true))));
	$this->cli_parameter['konfiguration'] = str_replace($makro,$ersetzen,$this->cli_parameter['konfiguration']);
	$this->LadeBenutzerdefinierteEinstellungen($einstellungen);
	$einstellungen['report']['ausgabe_datei_maske'] = str_replace($makro,$ersetzen,$einstellungen['report']['ausgabe_datei_maske']);
	$einstellungen['grafik']['ausgabe_datei_maske'] = str_replace($makro,$ersetzen,$einstellungen['grafik']['ausgabe_datei_maske']);
	$einstellungen['zwischenspeicher']['speicher_pfad'] = str_replace($makro,$ersetzen,$einstellungen['zwischenspeicher']['speicher_pfad']);
		if ( $einstellungen['rekorde']['monate_anzeigen'] === '*' )
		$einstellungen['rekorde']['monate_anzeigen'] = '1,2,3,4,5,6,7,8,9,10,11,12';
		if ( $einstellungen['wieselflink']['monate_anzeigen'] === '*' )
		$einstellungen['wieselflink']['monate_anzeigen'] = '1,2,3,4,5,6,7,8,9,10,11,12';
	$einstellungen['grafik']['diagramm_abstand'] = 50; // TODO: zur Zeit noch hart kodiert
	return true;
	}

	public function BearbeiteKommandozeilenParameter($parameter){
		if ( !is_array($parameter) )
		return false;
		foreach ( $parameter as $v ){
			if ( substr($v,0,1) === '-' && substr($v,1,1) === 'v' )
			$this->cli_parameter['debug_ausgabe'] = substr_count($v,'v');
			if ( substr($v,0,1) === '-' && substr($v,1,1) === 'd' )
			$this->cli_parameter['update_download'] = true;
			if ( substr($v,0,1) === '-' && substr($v,1,1) === 'i' )
			$this->cli_parameter['update_install'] = true;
			if ( substr($v,0,2) === '--' ){
			$v = explode('=',$v);
			$k = substr($v[0],2);
			unset($v[0]);
			$v = implode('=',$v);
				switch ( $k ){
				case 'dry-run':
				define('HEY_DONT_YOU_CHANGE_DATA','true');
				break;
				case 'station':
				$this->cli_parameter['station'] = preg_replace('/[^a-z]+/i','',$v);
				break;
				case 'vergleich':
				$this->cli_parameter['vergleich'] = preg_replace('/[^0-9,\-\*]+/','',$v);
					if ( $this->cli_parameter['vergleich'] === '*' )
					$this->cli_parameter['vergleich'] = '1700-'.date('Y',mktime(0,0,0,1,1,date('Y')-1));
				break;
				case 'jahr':
				$this->cli_parameter['jahr'] = intval($v);
				break;
				case 'typ':
				$this->cli_parameter['typ'] = ( in_array($v,array('text','csv','html','xml','abweichung','mittel','absolut'),true) || is_numeric($v) ) ? $v : 'text';
				break;
				case 'bedingung':
				$this->cli_parameter['bedingung'] = preg_replace('/[^a-z0-9_\-<>= ]+/i','',$v);
				break;
				case 'konfiguration':
				$this->cli_parameter['konfiguration'] = 'file://'.preg_replace('/[^a-z0-9_\/\.~]+/i','',$v);
				break;
				case 'benutzer1':
				$this->cli_parameter['benutzer1'] = preg_replace('/[^a-z0-9_\/\.]+/i','',$v);
				break;
				case 'benutzer2':
				$this->cli_parameter['benutzer2'] = preg_replace('/[^a-z0-9_\/\.]+/i','',$v);
				break;
				case 'benutzer3':
				$this->cli_parameter['benutzer3'] = preg_replace('/[^a-z0-9_\/\.]+/i','',$v);
				break;
				case 'benutzer4':
				$this->cli_parameter['benutzer4'] = preg_replace('/[^a-z0-9_\/\.]+/i','',$v);
				break;
				default:
				$this->cli_parameter['aktion'] = $k;
				break;
				}
			}
		}
	return true;
	}

	protected function LadeBenutzerdefinierteEinstellungen(&$einstellungen){
	$this->KonsolenAusgabe(__FUNCTION__.'()',3);
		if ( file_exists($this->cli_parameter['konfiguration']) ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Datei "'.$this->cli_parameter['konfiguration'].'" gefunden',3);
		$roh = parse_ini_file($this->cli_parameter['konfiguration']);
			foreach ( $roh as $schluessel=>$wert ){
			$teile = explode('.',$schluessel);
				switch ( sizeof($teile) ){
				case 2:
					if ( isset($einstellungen[$teile[0]][$teile[1]]) ){
					$wert = $this->BenutzerWertPruefen($einstellungen[$teile[0]][$teile[1]],$wert);
						if ( $wert !== null ){
						$this->KonsolenAusgabe(__FUNCTION__.'() Konfigurationswert "'.$schluessel.'" auf "'.$wert.'" geändert',2);
							if ( $wert === '(unset)' )
							unset($einstellungen[$teile[0]][$teile[1]]);
							else
							$einstellungen[$teile[0]][$teile[1]] = $wert;
						}
					}
				break;
				case 3:
					if ( isset($einstellungen[$teile[0]][$teile[1]][$teile[2]]) ){
					$wert = $this->BenutzerWertPruefen($einstellungen[$teile[0]][$teile[1]][$teile[2]],$wert);
						if ( $wert !== null ){
						$this->KonsolenAusgabe(__FUNCTION__.'() Konfigurationswert "'.$schluessel.'" auf "'.$wert.'" geändert',2);
							if ( $wert === '(unset)' )
							unset($einstellungen[$teile[0]][$teile[1]][$teile[2]]);
							else
							$einstellungen[$teile[0]][$teile[1]][$teile[2]] = $wert;
						}
					}
				break;
				case 4:
					if ( isset($einstellungen[$teile[0]][$teile[1]][$teile[2]][$teile[3]]) ){
					$wert = $this->BenutzerWertPruefen($einstellungen[$teile[0]][$teile[1]][$teile[2]][$teile[3]],$wert);
						if ( $wert !== null ){
						$this->KonsolenAusgabe(__FUNCTION__.'() Konfigurationswert "'.$schluessel.'" auf "'.$wert.'" geändert',2);
							if ( $wert === '(unset)' )
							unset($einstellungen[$teile[0]][$teile[1]][$teile[2]][$teile[3]]);
							else
							$einstellungen[$teile[0]][$teile[1]][$teile[2]][$teile[3]] = $wert;
						}
					}
				break;
				}
			}
		}
		else
		return false;
	return true;
	}

	protected function BenutzerWertPruefen($alt,$neu){
		switch ( gettype($alt) ){
		case 'boolean':
		$neu = ( in_array($neu,array('true','yes','ja','1')) ) ? true : false;
		break;
		case 'integer':
		$neu = intval($neu);
		break;
		case 'string':
		// nix tun, string einfach weitergeben
		break;
		default:
		$neu = null;
		break;
		}
	return $neu;
	}

	protected function VektorGrafikCSSSaeubern($wert){
	return preg_replace('/[^a-z0-9#,"\-]+/','',$wert);
	}

	protected function ErmittleVergleichsJahre($jahre,$station){
	global $einstellungen;
	$this->KonsolenAusgabe(__FUNCTION__.'() '.$jahre,3);
	$verfuegbar = array(1700,(int)date('Y'));
	$zeitraum = array();
	$jahre = explode(',',$jahre);
		if ( extension_loaded('simplexml') ){
			if ( file_exists($einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$this->cli_parameter['station'].'.manifest') ){
			$manifest = simplexml_load_file($einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$this->cli_parameter['station'].'.manifest');
				if ( isset($manifest->zeitreihe) ){
				$manifest = explode(' ',$manifest->zeitreihe);
				$verfuegbar = array((int)substr($manifest[0],0,4),(int)substr($manifest[1],0,4));
				}
			}
		}
		foreach ( $jahre as $wert ){
			if ( strpos($wert,'-') ){
			$wert = explode('-',$wert);
				if ( sizeof($wert) !== 2 || !is_numeric($wert[0]) || !is_numeric($wert[1]) )
				continue;
				for ( $a = (int)$wert[0] ; $a <= (int)$wert[1] ; $a++ )
				$zeitraum[] = $a;
			}
			else
			$zeitraum[] = (int)$wert;
		}
		foreach ( $zeitraum as $schluessel=>$wert ){
			if ( $wert < min($verfuegbar) || $wert > max($verfuegbar) )
			unset($zeitraum[$schluessel]);
		}
		if ( preg_match('/^(\d+)\-(\d+)$/m',$this->cli_parameter['vergleich'],$vergleich) ){
			if ( (int)$vergleich[1] < min($verfuegbar) )
			$vergleich[1] = min($verfuegbar);
			if ( (int)$vergleich[2] > max($verfuegbar) )
			$vergleich[2] = max($verfuegbar);
		unset($vergleich[0]);
		$this->cli_parameter['vergleich'] = implode('-',$vergleich);
		}
	return array_unique($zeitraum);
	}

	protected function SchluesselWertNachString($daten){
	$ausgabe = '';
		foreach ( $daten as $schluessel=>$wert )
		$ausgabe .= $schluessel."='".$wert."' ";
	return rtrim($ausgabe);
	}

	protected function MakrosErsetzen(&$eingabe,$wert){
	global $einstellungen;
	$eingabe = str_replace('%w',$einstellungen['grafik']['breite'],$eingabe);
	$eingabe = str_replace('%h',$einstellungen['grafik']['hoehe'],$eingabe);
	$eingabe = str_replace('!!',$einstellungen['grafik']['diagramm_abstand']*2,$eingabe); // nicht tauschen mit !
	$eingabe = str_replace('!',$einstellungen['grafik']['diagramm_abstand'],$eingabe);
	}

	protected function ZwischenspeicherLesen(&$datei){
		if ( !file_exists($datei) )
		return false;
	$daten = file_get_contents($datei);
	$pruefsumme = strpos($daten,'checksum=');
		if ( $pruefsumme !== false )
		$pruefsumme = substr($daten,$pruefsumme+9,8);
	$daten = substr($daten,strpos($daten,"\r\n\r\n<=>")+7);
	$daten = str_replace(array("\r","\n"),array('',''),$daten);
		if ( is_string($pruefsumme) && $pruefsumme !== sprintf('%x',crc32($daten)) )
		return false;
	return unserialize($daten);
	}

	protected function ZwischenspeicherSchreiben(&$datei,&$daten,$kopf){
	$serialisiert = serialize($daten);
	$cache = chunk_split("; ".$kopf." checksum=".sprintf("%x",crc32($serialisiert))."\r\n\r\n<=>".$serialisiert);
	return $this->file_put_contents_wrapper($datei,$cache);
	}

	protected function FiltereDatenNachDekaden(&$datensatz,&$daten_fertig,$jahre){
	global $einstellungen;
	$daten_temp = array();
	$daten_fertig = array();
	$tage_bearbeitet = 0;
		if ( !is_array($jahre) && is_numeric($jahre) )
		$jahre = array((int)$jahre);
	$this->KonsolenAusgabe(__FUNCTION__.'() Die Jahre '.implode(',',$jahre).' werden ausgewählt',2);
	$this->KonsolenAusgabe(__FUNCTION__.'() '.sizeof($datensatz).' Datensätze werden gefiltert',2);
		foreach ( $datensatz as $daten ){
			if ( !in_array($daten['jahr'],$jahre,true) )
			continue;
		$dekade = $this->ErmittleDekade($daten['tag']);
		$schluessel = $daten['monat'].'/'.$dekade;
			if ( !isset($daten_temp[$schluessel]) )
			$daten_temp[$schluessel] = $this->grundgeruest_werte;
			foreach ( $this->datenreihen as $wert ){
				if ( $daten_temp[$schluessel][$wert] === 0 )
				$daten_temp[$schluessel][$wert] = array();
				//if ( $daten[$wert] !== '---' )
				$daten_temp[$schluessel][$wert][] = $daten[$wert];
			}
		$tage_bearbeitet++;
		}
	$this->KonsolenAusgabe(__FUNCTION__.'() '.$tage_bearbeitet.' Tage wurden bearbeitet',2);
		foreach ( $daten_temp as $schluessel=>$daten ){
			foreach ( $this->datenreihen as $wert ){
				if ( sizeof($daten_temp[$schluessel][$wert]) === 0 )
				continue;
				if ( substr($wert,0,1) === '%' ){
					if ( $schluessel === '2/3' ){
						if ( sizeof($jahre) === 1 )
						$tage_in_dekade = date('t',mktime(0,0,0,2,1,$jahre[0]))-20;
						else
						$tage_in_dekade = 8;
					}
					elseif ( in_array($schluessel,array('1/3','3/3','5/3','7/3','8/3','10/3','12/3')) )
					$tage_in_dekade = 11;
					else
					$tage_in_dekade = 10;
				$daten_fertig[$schluessel][$wert] = round( array_sum($daten_temp[$schluessel][$wert]) / sizeof($daten_temp[$schluessel][$wert]) * $tage_in_dekade, 0);
				}
				else{
				$this->UngueltigeDatensaetzeEntfernen($daten_temp[$schluessel][$wert],sprintf('%s::%s',$schluessel,$wert));
				$daten_fertig[$schluessel][$wert] = round( array_sum($daten_temp[$schluessel][$wert]) / sizeof($daten_temp[$schluessel][$wert]), 1);
				}
			}
		}
	$this->KonsolenAusgabe(__FUNCTION__.'() Filterung abgeschlossen',2);
	}

	protected function FiltereDatenNachJahre(&$datensatz,&$daten_fertig,$jahre){
	$daten_fertig = array();
	$tage_bearbeitet = 0;
		if ( !is_array($jahre) && is_numeric($jahre) )
		$jahre = array((int)$jahre);
	$this->KonsolenAusgabe(__FUNCTION__.'() Die Jahre '.implode(',',$jahre).' werden ausgewählt',2);
	$this->KonsolenAusgabe(__FUNCTION__.'() '.sizeof($datensatz).' Datensätze werden gefiltert',2);
		foreach ( $datensatz as $daten ){
			if ( !in_array($daten['jahr'],$jahre,true) )
			continue;
		$daten_fertig[] = $daten;
		$tage_bearbeitet++;
		}
	$this->KonsolenAusgabe(__FUNCTION__.'() '.$tage_bearbeitet.' Tage wurden bearbeitet',2);
	$this->KonsolenAusgabe(__FUNCTION__.'() Filterung abgeschlossen',2);
	}

	protected function HoleRohDaten($station,$einzeljahr=''){
	global $einstellungen;
	$datensatz = array();
	$typ = $einstellungen['daten'][$this->cli_parameter['station']]['typus'];
	$sonnenschein_zwischenspeicher_pfad = $einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$station.'.00000000.sunshine';
		if ( extension_loaded('simplexml') && file_exists($einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$this->cli_parameter['station'].'.manifest') )
		$manifest = simplexml_load_file($einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$this->cli_parameter['station'].'.manifest');
	$this->KonsolenAusgabe(__FUNCTION__.'() Für Station '.$station.' mit dem Typ '.$typ,2);
	$letzter_satz = '00000000';
		if ( $this->nutze_optimierungen ){
		$sonnenschein_daten = $this->ZwischenspeicherLesen($sonnenschein_zwischenspeicher_pfad);
			if ( is_array($sonnenschein_daten) && sizeof($sonnenschein_daten) >= 365 ){
			$this->KonsolenAusgabe('Vorberechnete astronomische Sonnenscheindauer wurde aus dem Zwischenspeicher geholt',2);
			$this->KonsolenAusgabe('Sonnenscheindauer wurde berechnet',2);
			}
			else
			$sonnenschein_daten = $this->Berechne_Astronomische_Sonnenscheindauer($einstellungen['daten'][$station]['position']);
		}
		else
		$sonnenschein_daten = $this->Berechne_Astronomische_Sonnenscheindauer($einstellungen['daten'][$station]['position']);

		foreach ( $einstellungen['daten'][$station]['roh_daten'] as $id=>$datei ){
		$this->KonsolenAusgabe('Bearbeite Roh-Datei #'.$id.' - '.basename($datei),2);
		$uuid = sprintf('%u',crc32($datei));
		$lokaler_pfad = $einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$this->cli_parameter['station'].'.'.$uuid;
			if ( !file_exists($lokaler_pfad) ){
			$this->KonsolenAusgabe(__FUNCTION__.'() Roh-Datei konnte nicht im Zwischenspeicher gefunden werden',2);
			continue;
			}
		$gefundene_jahre = 'gefundene_jahre_'.$uuid;
			if ( $this->nutze_optimierungen && is_numeric($einzeljahr) && isset($manifest) && isset($manifest->$gefundene_jahre) ){
			$gefundene_jahre = explode(',',$manifest->$gefundene_jahre);
				if ( !in_array($einzeljahr,$gefundene_jahre) ){
				$this->KonsolenAusgabe(__FUNCTION__.'() Das geforderte Einzeljahr '.$einzeljahr.' nicht gefunden',2);
				$this->KonsolenAusgabe(__FUNCTION__.'() Überspringe daher das weitere Bearbeiten dieser Roh-Datei',2);
				continue;
				}
			}
		$pruefsumme = 'pruefsumme_'.$uuid;
			if ( isset($manifest) && isset($manifest->$pruefsumme) ){
				if ( sha1_file($lokaler_pfad) !== strval($manifest->$pruefsumme) )
				$this->KonsolenAusgabe('Die Roh-Datei wurde seit dem letzten Import verändert',2);
			}
		$roh = file($lokaler_pfad);
		$this->KonsolenAusgabe(__FUNCTION__.'() Lese Datei aus dem Zwischenspeicher '.basename($lokaler_pfad),2);
			if ( !is_array($roh) || sizeof($roh) < 10 )
			continue;
		$this->KonsolenAusgabe(__FUNCTION__.'() Gefundene Zeilen '.sizeof($roh),2);

// NOTE: Güte-Angabe der Daten berücksichtigen?

			switch ( $typ ){ // TODO: ließe sich auf etwas hübscheres refaktorisieren
			// (switch innerhalb des foreach, letzter teil jeweils gleich)
			case 'dwd_kl2000':
				foreach ( $roh as $zeile ){
				// NOTE: hier schon nach jahren zu filtern reduziert die rechenzeit
				// (auf aktuellen rechnern) nur unwesentlich
					if ( strlen($zeile) < 128 )
					continue;
				$satz = array(
				'jahr'=>(int)substr($zeile,7,4),
				'monat'=>(int)substr($zeile,11,2),
				'tag'=>(int)substr($zeile,13,2),
				'luftdruck_mit'=>(double)substr($zeile,37,5)/10,
				'temperatur_max'=>(double)substr($zeile,43,4)/10,
				'temperatur_min'=>(double)substr($zeile,48,4)/10,
				'temperatur_mit'=>(double)substr($zeile,78,4)/10,
				'feuchte_mit'=>(int)substr($zeile,130,2),
				'wind_mit'=>(int)substr($zeile,161,2),
				'sonne'=>(double)substr($zeile,195,3)/10,
/*				'wolken_6h'=>(int)substr($zeile,164,2),
				'wolken_12h'=>(int)substr($zeile,173,2),
				'wolken_18h'=>(int)substr($zeile,182,2),*/
				'wolken_mit'=>(double)substr($zeile,191,3)/10,
				'niederschlag'=>(double)substr($zeile,246,3)/10,
				'schneehoehe'=>(double)substr($zeile,252,2),
				'%tropentag'=>0,
				'%sommertag'=>0,
				'%frosttag'=>0,
				'%eistag'=>0,
				'%tropennacht'=>0,
				'%regentag'=>0,
				'%schneetag'=>0,
				);
				$zeitstempel = sprintf('%02d%02d',$satz['monat'],$satz['tag']);
				$this->RohDatenValidieren($satz);

					if ( is_numeric($satz['temperatur_max']) && $satz['temperatur_max'] >= 30 ){
					$satz['%tropentag'] = 1;
					$satz['%sommertag'] = 1;
					}
					elseif ( is_numeric($satz['temperatur_max']) && $satz['temperatur_max'] >= 25 )
					$satz['%sommertag'] = 1;

					if ( is_numeric($satz['temperatur_max']) && $satz['temperatur_max'] <= 0 ){
					$satz['%eistag'] = 1;
					$satz['%frosttag'] = 1;
					}
					elseif ( is_numeric($satz['temperatur_min']) && $satz['temperatur_min'] <= 0 )
					$satz['%frosttag'] = 1;

					if ( is_numeric($satz['temperatur_min']) && $satz['temperatur_min'] >= 20 )
					$satz['%tropennacht'] = 1;

					if ( is_numeric($satz['niederschlag']) && $satz['niederschlag'] >= $this->niederschlagsgrenze_fuer_regentag_in_mm )
					$satz['%regentag'] = 1;

					if ( is_numeric($satz['schneehoehe']) && $satz['schneehoehe'] > 0 )
					$satz['%schneetag'] = 1;

					if ( isset($sonnenschein_daten[$zeitstempel]) && $satz['sonne'] !== '---' )
					$satz['%sonnenschein'] = round($satz['sonne']/$sonnenschein_daten[$zeitstempel],2);
					else
					$satz['%sonnenschein'] = '---';

				$datensatz[] = $satz;
				$letzter_satz = sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']);
				}

			$this->KonsolenAusgabe(__FUNCTION__.'() Datei abgeschlossen',2);
			break;
			case 'dwd_hist':
				foreach ( $roh as $zeile ){
					if ( strlen($zeile) < 130 || strlen($zeile) > 312 )
					continue;
				$satz = array(
				'jahr'=>(int)substr($zeile,10,4),
				'monat'=>(int)substr($zeile,14,2),
				'tag'=>(int)substr($zeile,16,2),
				'luftdruck_mit'=>round((double)substr($zeile,56,7),1),
				'temperatur_max'=>(double)substr($zeile,88,6),
				'temperatur_min'=>(double)substr($zeile,80,6),
				'temperatur_mit'=>(double)substr($zeile,48,7),
				'feuchte_mit'=>(int)substr($zeile,34,4),
				'wind_mit'=>(int)substr($zeile,65,5),
				'sonne'=>round((double)substr($zeile,115,8),1),
				'wolken_mit'=>(double)substr($zeile,25,5),
				'niederschlag'=>(double)substr($zeile,108,5),
				'schneehoehe'=>-1, // TODO: einbauen, falls verfügbar
				'%tropentag'=>0,
				'%sommertag'=>0,
				'%frosttag'=>0,
				'%eistag'=>0,
				'%tropennacht'=>0,
				'%regentag'=>0,
				'%schneetag'=>0
				);
				$zeitstempel = sprintf('%02d%02d',$satz['monat'],$satz['tag']);
				$this->RohDatenValidieren($satz);

					if ( is_numeric($satz['temperatur_max']) && $satz['temperatur_max'] >= 30 ){
					$satz['%tropentag'] = 1;
					$satz['%sommertag'] = 1;
					}
					elseif ( is_numeric($satz['temperatur_max']) && $satz['temperatur_max'] >= 25 )
					$satz['%sommertag'] = 1;

					if ( is_numeric($satz['temperatur_max']) && $satz['temperatur_max'] <= 0 ){
					$satz['%eistag'] = 1;
					$satz['%frosttag'] = 1;
					}
					elseif ( is_numeric($satz['temperatur_min']) && $satz['temperatur_min'] <= 0 )
					$satz['%frosttag'] = 1;

					if ( is_numeric($satz['temperatur_min']) && $satz['temperatur_min'] >= 20 )
					$satz['%tropennacht'] = 1;

					if ( is_numeric($satz['niederschlag']) && $satz['niederschlag'] >= $this->niederschlagsgrenze_fuer_regentag_in_mm )
					$satz['%regentag'] = 1;

					if ( is_numeric($satz['schneehoehe']) && $satz['schneehoehe'] > 0 )
					$satz['%schneetag'] = 1;

					if ( isset($sonnenschein_daten[$zeitstempel]) && $satz['sonne'] !== '---' )
					$satz['%sonnenschein'] = round($satz['sonne']/$sonnenschein_daten[$zeitstempel],2);
					else
					$satz['%sonnenschein'] = '---';

				$datensatz[] = $satz;
				$letzter_satz = sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']);
				}

			$this->KonsolenAusgabe(__FUNCTION__.'() Datei abgeschlossen',2);
			break;
			}

		}
	unset($roh,$satz);
	$verschnitt = intval(substr($letzter_satz,-2))%10;
		if ( $verschnitt !== 0 && !in_array(substr($letzter_satz,4),array('0228','0229')) && (int)substr($letzter_satz,-2) !== 31 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Verwerfe '.$verschnitt.' Tage, da die letzte Dekade unvollständig ist',2);
			for ( $i = 1 ; $i <= $verschnitt ; $i++ )
			array_pop($datensatz);
		$letzter_satz = array_pop($datensatz);
		$datensatz[] = $letzter_satz;
		$this->KonsolenAusgabe(__FUNCTION__.'() Der letzte Datensatz trägt das Kalenderdatum "'.sprintf('%04d%02d%02d',$letzter_satz['jahr'],$letzter_satz['monat'],$letzter_satz['tag']).'"',2);
		}
	$this->KonsolenAusgabe(__FUNCTION__.'() '.sizeof($datensatz).' Datensätze eingelesen und verarbeitet',2);
		if ( $this->nutze_optimierungen && !file_exists($sonnenschein_zwischenspeicher_pfad) ){
		$this->ZwischenspeicherSchreiben($sonnenschein_zwischenspeicher_pfad,$sonnenschein_daten,'sunshine data cache - ');
		$this->KonsolenAusgabe('Berechnete astronomische Sonnenscheindauer wurde zum schnelleren Bereitstellen in den Zwischenspeicher gepackt',2);
		}
	return $datensatz;
	}

	/* NOTE: Berücksichtigt nicht die Höhe der Station. Aus der php.ini folgt
	; The best Overall figure for zenith is 90+(50/60) degrees for true sunrise/sunset
	; Civil twilight 96 degrees - Conventionally used to signify twilight
	; Nautical twilight 102 degrees - the point at which the horizon stops being visible at sea.
	; Astronical twilight at 108 degrees - the point when Sun stops being a source of any illumination. */
	protected function Berechne_Astronomische_Sonnenscheindauer($geokoordinaten){
		if ( !preg_match('/^[\d\.]+ [\d\.]+$/uD',$geokoordinaten) )
		return false;
	$daten = array();
	$zenit = 90+(50/60);
	$geokoordinaten = explode(' ',$geokoordinaten);
		for ( $a = 1 ; $a <= 12 ; $a++ ){
			for ( $b = 1 ; $b <= 31 ; $b++ ){
				if ( checkdate($a,$b,2000) ){ // Schaltjahr
				$schluessel = sprintf('%02d',$a).sprintf('%02d',$b);
				$sa = date_sunrise(gmmktime(0,0,0,$a,$b,2000),SUNFUNCS_RET_TIMESTAMP,$geokoordinaten[0],$geokoordinaten[1],$zenit,0);
				$su = date_sunset(gmmktime(0,0,0,$a,$b,2000),SUNFUNCS_RET_TIMESTAMP,$geokoordinaten[0],$geokoordinaten[1],$zenit,0);
					if ( is_integer($sa) && is_integer($su) )
					$daten[$schluessel] = round(($su-$sa)/3600,1);
					else
					$daten[$schluessel] = 24;
				}
			}
		}
	$this->KonsolenAusgabe('Astronomische Sonnenscheindauer wurde berechnet',2);
	return $daten;
	}

	protected function RohDatenValidieren(&$satz){
		if ( $satz['temperatur_max'] < -50 || $satz['temperatur_max'] > 75 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['temperatur_max'].'" bei "temperatur_max" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['temperatur_max'] = '---';
		}
		if ( $satz['temperatur_min'] < -90 || $satz['temperatur_min'] > 75 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['temperatur_min'].'" bei "temperatur_min" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['temperatur_min'] = '---';
		}
		if ( $satz['temperatur_mit'] < -50 || $satz['temperatur_mit'] > 75 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['temperatur_mit'].'" bei "temperatur_mit" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['temperatur_mit'] = '---';
		}
		if ( $satz['luftdruck_mit'] < 500 || $satz['luftdruck_mit'] > 1100 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['luftdruck_mit'].'" bei "luftdruck_mit" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['luftdruck_mit'] = '---';
		}
		if ( $satz['feuchte_mit'] < 0 || $satz['feuchte_mit'] > 100 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['feuchte_mit'].'" bei "feuchte_mit" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['feuchte_max'] = '---';
		}
		if ( $satz['wind_mit'] < 0 || $satz['wind_mit'] > 255 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['wind_mit'].'" bei "wind_mit" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['wind_mit'] = '---';
		}
		if ( $satz['sonne'] < 0 || $satz['sonne'] > 24 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['sonne'].'" bei "sonne" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['sonne'] = '---';
		}
		if ( $satz['niederschlag'] < 0 || $satz['niederschlag'] > 1000 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['niederschlag'].'" bei "niederschlag" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['niederschlag'] = '---';
		}
		if ( $satz['schneehoehe'] < 0 || $satz['schneehoehe'] > 1000 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['schneehoehe'].'" bei "schneehoehe" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['schneehoehe'] = '---';
		}
/*		if ( $satz['wolken_6h'] < 0 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['wolken_6h'].'" bei "wolken_6h" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['wolken_6h'] = '---';
		}
		if ( $satz['wolken_12h'] < 0 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['wolken_12h'].'" bei "wolken_12h" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['wolken_12h'] = '---';
		}
		if ( $satz['wolken_18h'] < 0 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['wolken_18h'].'" bei "wolken_18h" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['wolken_18h'] = '---';
		}*/
		if ( $satz['wolken_mit'] < 0 || $satz['wolken_mit'] > 10 ){
		$this->KonsolenAusgabe(__FUNCTION__.'() Ungültiger Wert "'.$satz['wolken_mit'].'" bei "wolken_mit" mit dem Datum '.sprintf('%04d%02d%02d',$satz['jahr'],$satz['monat'],$satz['tag']),3);
		$satz['wolken_mit'] = '---';
		}
	}

	public function UngueltigeDatensaetzeEntfernen(&$werte,$name=''){
	$ratio = 1;
	$entfernt = 0;
		if ( is_array($werte) ){
			foreach ( $werte as $schluessel=>$wert ){
				if ( $wert === '---' ){
				unset($werte[$schluessel]);
				$name .= ' +'.$schluessel;
				$entfernt++;
				}
			}
		}
		if ( $entfernt > 0 ){
		$menge = sizeof($werte);
		$ratio = round(($menge-$entfernt)/$menge,1);
		$this->KonsolenAusgabe(__FUNCTION__.'() '.$entfernt.' Stück aus "'.trim($name).'" entfernt, '.$menge.' (='.$ratio.') sind gültig.',2);
		}
	return $ratio;
	}

	public function KonsolenAusgabe($text,$gewicht){
		if ( intval($gewicht) <= $this->cli_parameter['debug_ausgabe'] ){
		echo '['.sprintf('%6.3f',round(microtime(true)-$this->startzeit,3)).'s ::';
		echo ' '.sprintf('%4.1f',round(memory_get_usage(true)/1048576,1)).' MiB ] ';
		echo $text;
		echo chr(10);
		}
		if ( (int)$gewicht === -1 )
		die();
	return true;
	}

	public function file_put_contents_wrapper(){
		if ( defined('HEY_DONT_YOU_CHANGE_DATA') )
		return true;
	$args = func_get_args();
	return call_user_func_array('file_put_contents',$args);
	}

	public function GPSNachLesbar($daten){
	$ausgabe = '';
	$daten = explode(' ',$daten);
	$ausgabe .= ( doubleval($daten[0]) > 0 ) ? (double)$daten[0].'N ' : (double)$daten[0].'S ';
	$ausgabe .= ( doubleval($daten[1]) > 0 ) ? (double)$daten[1].'E ' : (double)$daten[1].'W ';
	return rtrim($ausgabe);
	}

	public function ZeitstempelNachLesbar($datum){
	$tag = substr($datum,6);
	$monat = substr($datum,4,2);
	$jahr = substr($datum,0,4);
	return $tag.'. '.strftime('%B',strtotime('1999'.$monat.'01')).' '.$jahr;
	}

	public function ErmittleDekade($tag){
	$tag = intval($tag);
		if ( $tag < 11 )
		return 1;
		elseif ( $tag < 21 )
		return 2;
		else
		return 3;
	}

	public function DekadeNachLokalisiertesDatum($daten,$monat='%b'){
	$daten = explode('/',$daten);
	$datum = mktime(0,0,0,$daten[0],1,2000);
	return strftime($monat,$datum).chr(10).$daten[1];
	}

	public function ErmittleDekadenAuswahl($modul){
	global $einstellungen;
	$dekaden_auswahl = array();
	$daten_temp = explode(',',$einstellungen[$modul]['dekaden_auswahl']);
		if ( $daten_temp[0] === '*' ){
			for ( $m = 1 ; $m <= 12 ; $m++ ){
				for ( $d = 1 ; $d <= 3 ; $d++ )
				$dekaden_auswahl[] = $m.'/'.$d;
			}
		}
		else{
			foreach ( $daten_temp as $wert ){
			preg_match('|^([a-z0-9]{1,3})[^a-z0-9]+([123\*]{1})$|iD',$wert,$wert);
				if ( is_array($wert) && sizeof($wert) === 3 ){
				$monat = $this->StrMonatNachZahl($wert[1]);
					if ( $monat === 0 )
					continue;
					if ( $wert[2] === '*' ){
					$dekaden_auswahl[] = $monat.'/1';
					$dekaden_auswahl[] = $monat.'/2';
					$dekaden_auswahl[] = $monat.'/3';
					}
					else
					$dekaden_auswahl[] = $monat.'/'.(int)$wert[2];
				}
			}
		}
	return $dekaden_auswahl;
	}

	public function StrMonatNachZahl($monat){
	$monat = strtolower($monat);
	$zk = array('jan','feb','mar','apr','mai','jun','jul','aug','sep','okt','nov','dez');
	$za = array(1,2,3,4,5,6,7,8,9,10,11,12);
	return intval(str_replace($zk,$za,$monat));
	}

	public function StrZahlNachMonat($monat){
			switch ( (int)$monat ){
			case 1: $name = 'Jan'; break;
			case 2: $name = 'Feb'; break;
			case 3: $name = 'Mar'; break;
			case 4: $name = 'Apr'; break;
			case 5: $name = 'May'; break;
			case 6: $name = 'Jun'; break;
			case 7: $name = 'Jul'; break;
			case 8: $name = 'Aug'; break;
			case 9: $name = 'Sep'; break;
			case 10: $name = 'Oct'; break;
			case 11: $name = 'Nov'; break;
			case 12: $name = 'Dec'; break;
			}
	return $name;
	}

	public function HoleVergleichsMittelDerJahre($station,$jahre){
	global $einstellungen;
	$this->KonsolenAusgabe('Berechne Vergleichsmittel der Station '.$station.' für '.$jahre,1);
	$daten = array();
	$jahre = $this->ErmittleVergleichsJahre($jahre,$station);
	$uuid = sprintf('%u',crc32(implode('',$jahre)));
	$lokaler_pfad = $einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$station.'.'.$uuid.'.climate';
		if ( $this->nutze_optimierungen ){
		$daten = $this->ZwischenspeicherLesen($lokaler_pfad);
			if ( is_array($daten) && sizeof($daten) === 36 ){
			$this->KonsolenAusgabe('Vorberechnete Daten wurden aus dem Zwischenspeicher geholt',2);
			$this->KonsolenAusgabe('Vergleichsmittel wurde berechnet',2);
			return $daten;
			}
		}
	$datensatz = $this->HoleRohDaten($station);
	$this->FiltereDatenNachDekaden($datensatz,$daten,$jahre);
		if ( $this->nutze_optimierungen ){
		$this->ZwischenspeicherSchreiben($lokaler_pfad,$daten,'clino data cache - years='.implode(',',$jahre));
		$this->KonsolenAusgabe('Berechnete Daten wurden zum schnelleren Bereitstellen in den Zwischenspeicher gepackt',2);
		}
	$this->KonsolenAusgabe('Vergleichsmittel wurde berechnet',2);
	return $daten;
	}

	public function HoleStationsDatenDesJahres($station,$jahr){
	$this->KonsolenAusgabe('Berechne Jahresdaten der Station '.$station.' für '.$jahr,1);
	$daten = array();
	$datensatz = $this->HoleRohDaten($station,$jahr);
	$this->FiltereDatenNachDekaden($datensatz,$daten,$jahr);
	$this->KonsolenAusgabe('Jahresdaten wurden berechnet',2);
	return $daten;
	}

	public function HoleRoheDatenDerJahre($station,$jahr){
	$this->KonsolenAusgabe('Berechne alle Daten der Station '.$station.' für '.$jahr,1);
	$daten = array();
	$jahr = $this->ErmittleVergleichsJahre($jahr,$station);
	$datensatz = $this->HoleRohDaten($station);
	$this->FiltereDatenNachJahre($datensatz,$daten,$jahr);
	$this->KonsolenAusgabe('Daten wurden berechnet',2);
	return $daten;
	}

	public function BerechneYAchse_Abweichung($wert){
	global $einstellungen;
	$diagramm_hoehe = $einstellungen['grafik']['hoehe']-(2*$einstellungen['grafik']['diagramm_abstand']);
	$diagramm_mitte = ($diagramm_hoehe/2);
	$balken_hoehe = (abs($wert)/$einstellungen['grafik']['diagramm_y_achse_maximum'])*$diagramm_mitte;
	$koordinaten = array($diagramm_mitte,$diagramm_mitte,0); // absolut, start, höhe
		if ( $wert < 0 ){
		$koordinaten[0] = $diagramm_mitte+$balken_hoehe;
		$koordinaten[1] = $diagramm_mitte;
		$koordinaten[2] = $balken_hoehe;
		}
		elseif ( $wert > 0 ){
		$koordinaten[0] = $diagramm_mitte-$balken_hoehe;
		$koordinaten[1] = $diagramm_mitte-$balken_hoehe;
		$koordinaten[2] = $balken_hoehe;
		}
	$koordinaten[0] += $einstellungen['grafik']['diagramm_abstand'];
	$koordinaten[1] += $einstellungen['grafik']['diagramm_abstand'];
	$this->KonsolenAusgabe(__FUNCTION__.'() wert='.$wert.' coords='.implode(',',$koordinaten),3);
	return $koordinaten;
	}

	public function BerechneYAchse_Absolut($wert,&$begrenzung){
	global $einstellungen;
	$diagramm_hoehe = $einstellungen['grafik']['hoehe']-(2*$einstellungen['grafik']['diagramm_abstand']);
	$werte_groesse = abs($begrenzung['max'])+abs($begrenzung['min']);
		if ( $wert >= 0 )
		$wert_abs = $wert+abs($begrenzung['min']);
		else
		$wert_abs = abs($begrenzung['min'])-abs($wert);
	$wert_hoehe = ($wert_abs/$werte_groesse)*$diagramm_hoehe;
	$koordinaten[0] = $diagramm_hoehe-$wert_hoehe+$einstellungen['grafik']['diagramm_abstand'];
	$this->KonsolenAusgabe(__FUNCTION__.'() wert='.$wert.' coords='.implode(',',$koordinaten),3);
	return $koordinaten;
	}

	public function VektorGrafikPuffer($gruppe,$element,$attribute,$daten=''){
	global $einstellungen;
	static $warteschlange = array();
		if ( $element === '%' )
		return $warteschlange;
	$attribute_roh = $attribute;
		if ( !isset($warteschlange[$gruppe]) )
		$warteschlange[$gruppe] = array();
	parse_str(str_replace(array(',','+'),array('&','%2B'),$attribute),$attribute);
		foreach ( $attribute as $schluessel=>$wert ){
			if ( in_array($schluessel,array('x','y','x1','x2','y1','y2','width','height'),true) ){
			preg_match('/^([0-9a-z!%]+)([\-\+]*[0-9a-z!%]*)$/D',str_replace('%2B','+',$wert),$berechnen);
			array_walk($berechnen,array('Dekaden_Analyse','MakrosErsetzen'));
				if ( isset($berechnen[2]) && strlen($berechnen[2]) > 0 ){
				$operator = substr($berechnen[2],0,1);
				$berechnen[2] = substr($berechnen[2],1);
					if ( $operator === '+' )
					$berechnen[0] = $berechnen[1]+$berechnen[2];
					elseif ( $operator === '-' )
					$berechnen[0] = $berechnen[1]-$berechnen[2];
				}
				if ( !isset($berechnen[0]) )
				$berechnen[0] = $wert;
#				if ( strlen($schluessel) <= 2 )
#				$berechnen[0] += 0.5;
			$attribute[$schluessel] = $berechnen[0];
			}
		}
		switch ( $element ){
		case 'line':
		$warteschlange[$gruppe][] = '<line '.$this->SchluesselWertNachString($attribute).' />';
		break;
		case 'rect':
		$warteschlange[$gruppe][] = '<rect '.$this->SchluesselWertNachString($attribute).' />';
		break;
		case 'circle':
		$warteschlange[$gruppe][] = '<circle '.$this->SchluesselWertNachString($attribute).' />';
		break;
		case 'text':
		$warteschlange[$gruppe][] = '<text '.$this->SchluesselWertNachString($attribute).'>'.$daten.'</text>';
		break;
		}
	$this->KonsolenAusgabe(__FUNCTION__.'() element='.$gruppe.':'.$wert.' attr='.preg_replace('/[\x00-\x1f]+/','',$attribute_roh),3);
	return true;
	}

	public function VektorGrafikZeichnen($kommentar){
	global $einstellungen;
	$gruppen = array('leinwand','kopf-ueberschrift','kopf-info','fuss','legende',
	'y-achse-aussen','y-achse-innen','x-achse-aussen','x-achse-innen',
	'diagramm-balken','diagramm-werte-zeigen','diagramm-werte');
//		$gruppen = array('x-achse-innen');
	$puffer = '<?xml version="1.0" encoding="UTF-8"?>
	<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
	<svg xmlns="http://www.w3.org/2000/svg"
	  xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:ev="http://www.w3.org/2001/xml-events"
	  version="1.1" baseProfile="full" contentStyleType="text/css"
	  width="'.intval($einstellungen['grafik']['breite']).'px" height="'.intval($einstellungen['grafik']['hoehe']).'px">
		  <desc>'.$kommentar.'</desc>
		  <defs>
		    <style type="text/css"><![CDATA[
		    svg { font-family:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftart_normal']).'; }
		    g#kopf-ueberschrift { font-family:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftart_ueberschrift']).';font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_ueberschrift_gross']).'; }
		    g#kopf-info { font-family:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftart_ueberschrift']).';font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_ueberschrift_klein']).'; }
		    g#fuss { font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_normal']).';opacity:0.75; }
		    g#legende rect { stroke:black;stroke-width:1px; }
		    g#legende text { font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_normal']).'; }
		    g#y-achse-aussen line { stroke:black;stroke-width:1px; }
		    g#y-achse-aussen text { font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_y_achse']).'; }
		    g#y-achse-innen line { stroke:gray;stroke-width:0.25px; }
		    g#y-achse-innen .nullinie { stroke:black;stroke-width:3px; }
		    g#x-achse-aussen line { stroke:black;stroke-width:1px; }
		    g#x-achse-aussen .gross { font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_x_achse_gross']).'; }
		    g#x-achse-aussen .klein { font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_x_achse_klein']).'; }
		    g#x-achse-innen line { stroke:black;stroke-width:1px; }
		    g#diagramm-balken rect { stroke:black;stroke-width:0.5px; }
		    g#diagramm-balken circle { stroke:black;stroke-width:0.5px; }
		    g#diagramm-werte-zeigen { stroke:none;opacity:0.33; }
		    g#diagramm-werte { font-family:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftart_festbreite']).';font-size:'.$this->VektorGrafikCSSSaeubern($einstellungen['grafik']['schriftgroesse_werte_zeigen']).'; }
	';
		foreach ( $einstellungen['grafik']['diagramm_balken_daten'] as $balken_schluessel=>$balken_name ){
		$balken_name = explode(',',$balken_name);
		$puffer .= '    .cfill'.$balken_schluessel.' { fill:'.$this->VektorGrafikCSSSaeubern($balken_name[1]).'; }'.chr(10);
		}
	$puffer .= '    ]]></style>
		    <linearGradient id="bg-gradient" y1="0%" y2="100%">
		    <stop offset="0%" stop-color="rgb(250,250,250)" />
		    <stop offset="100%" stop-color="rgb(180,180,180)" />
		    </linearGradient>
		  </defs>
	';
	$puffer = str_replace(chr(9),'',$puffer);
	$elemente = $this->VektorGrafikPuffer('','%',null,null);
		foreach ( $gruppen as $gruppe ){
			if ( !isset($elemente[$gruppe]) )
			continue;
		$puffer .= '  <g id="'.$gruppe.'">'.chr(10);
			foreach ( $elemente[$gruppe] as $element )
			$puffer .= '    '.$element.chr(10);
		$puffer .= '  </g>'.chr(10);
		}
	$puffer .= '</svg>';
	$groesse = file_put_contents($einstellungen['grafik']['ausgabe_datei_maske'],$puffer);
	$this->KonsolenAusgabe(__FUNCTION__.'() filesize='.$groesse,3);
	return true;
	}

}
?>
